/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.AsientoExclusivoDAO;
import com.rjconsultores.ventaboletos.entidad.AsientoExclusivo;
import com.rjconsultores.ventaboletos.entidad.Corrida;
import com.rjconsultores.ventaboletos.service.AsientoExclusivoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author rodrigo
 */
@Service("asientoExclusivoService")
public class AsientoExclusivoServiceImpl implements AsientoExclusivoService {

    @Autowired
    private AsientoExclusivoDAO asientoExclusivoDAO;

    public List<AsientoExclusivo> obtenerTodos() {
        return asientoExclusivoDAO.obtenerTodos();
    }

    public AsientoExclusivo obtenerID(Integer id) {
        return asientoExclusivoDAO.obtenerID(id);
    }

    @Transactional
    public AsientoExclusivo suscribir(AsientoExclusivo entidad) {
    	Integer usuarioId = 1;
    	if (UsuarioLogado.getUsuarioLogado() != null){
    		usuarioId = UsuarioLogado.getUsuarioLogado().getUsuarioId();
    	}
        entidad.setUsuarioId(usuarioId);
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return asientoExclusivoDAO.suscribir(entidad);
    }

    @Transactional
    public AsientoExclusivo actualizacion(AsientoExclusivo entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return asientoExclusivoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(AsientoExclusivo entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        asientoExclusivoDAO.actualizacion(entidad);
    }

	@Override
	public void borrarByCorrida(Corrida corrida) {
		asientoExclusivoDAO.borrarByCorrida(corrida);
		
	}
}
